## grafana 2.6.0+dfsg

=== docs/Makefile ===
.PHONY: all binary build cross default docs docs-build docs-shell shell test test-unit test-integration test-integration-cli test-docker-py validate

# env vars passed through directly to Docker's build scripts
# to allow things like `make DOCKER_CLIENTONLY=1 binary` easily
# `docs/sources/contributing/devenvironment.md ` and `project/PACKAGERS.md` have some limited documentation of some of these
DOCKER_ENVS := \
	-e BUILDFLAGS \
	-e DOCKER_CLIENTONLY \
	-e DOCKER_EXECDRIVER \
	-e DOCKER_GRAPHDRIVER \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TIMEOUT
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make DOCSDIR=docs docs-shell` (to create a bind mount in docs)
DOCS_MOUNT := $(if $(DOCSDIR),-v $(CURDIR)/$(DOCSDIR):/$(DOCSDIR))

# to allow `make DOCSPORT=9000 docs`
DOCSPORT := 8180

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
DOCKER_DOCS_IMAGE := grafana-docs-base$(if $(GIT_BRANCH),:$(GIT_BRANCH))

DOCKER_RUN_DOCS := docker run --rm -it $(DOCS_MOUNT) -e AWS_S3_BUCKET -e NOCACHE

# for some docs workarounds (see below in "docs-build" target)
GITCOMMIT := $(shell git rev-parse --short HEAD 2>/dev/null)

default: docs

docs: docs-build
	$(DOCKER_RUN_DOCS) -p $(if $(DOCSPORT),$(DOCSPORT):)8000 "$(DOCKER_DOCS_IMAGE)" mkdocs serve

docs-shell: docs-build
	$(DOCKER_RUN_DOCS) -p $(if $(DOCSPORT),$(DOCSPORT):)8000 "$(DOCKER_DOCS_IMAGE)" bash

docs-release: docs-build
	$(DOCKER_RUN_DOCS) -e OPTIONS -e BUILD_ROOT -e DISTRIBUTION_ID \
		-v $(CURDIR)/awsconfig:/docs/awsconfig \
		"$(DOCKER_DOCS_IMAGE)" ./release.sh

docs-test: docs-build
	$(DOCKER_RUN_DOCS) "$(DOCKER_DOCS_IMAGE)" ./test.sh

docs-build:
	git fetch https://github.com/grafana/grafana.git docs-2.1 && git diff --name-status FETCH_HEAD...HEAD -- . > changed-files
	echo "$(GIT_BRANCH)" > GIT_BRANCH
	echo "$(GITCOMMIT)" > GITCOMMIT
	docker build -t "$(DOCKER_DOCS_IMAGE)" .

=== debian/changelog ===
grafana (2.6.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #797702).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 13 Feb 2016 10:49:01 +1100

=== debian/control ===
Source: grafana
Section: web
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: pkg-go <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper (>= 9), dh-golang, dh-systemd
    ,golang-github-aws-aws-sdk-go-dev (>= 1.0.0)
      ,golang-github-bradfitz-gomemcache-dev
    ,golang-toml-dev | golang-github-burntsushi-toml-dev
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-go-ldap-ldap-dev
    ,golang-github-go-sql-driver-mysql-dev
    ,golang-github-go-xorm-xorm-dev
    ,golang-github-go-xorm-core-dev
    ,golang-github-go-ini-ini-dev
  ,golang-github-go-macaron-gzip-dev
  ,golang-github-go-macaron-binding-dev
  ,golang-github-go-macaron-session-dev
    ,golang-github-gosimple-slug-dev
    ,golang-github-jmespath-go-jmespath-dev
    ,golang-github-jtolds-gls-dev
      ,golang-github-klauspost-compress-dev
      ,golang-github-klauspost-cpuid-dev
      ,golang-github-klauspost-crc32-dev
    ,golang-github-lib-pq-dev
    ,golang-github-mattn-go-sqlite3-dev
    ,golang-github-rainycape-unidecode-dev
    ,golang-github-smartystreets-goconvey-dev
    ,golang-github-streadway-amqp-dev
    ,golang-github-unknwon-com-dev
    ,golang-github-vaughan0-go-ini-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-dev
    ,golang-gopkg-asn1-ber.v1-dev
    ,golang-gopkg-bufio.v1-dev
    ,golang-gopkg-ini.v1-dev
    ,golang-gopkg-macaron.v1-dev
    ,golang-gopkg-redis.v2-dev
    ,node-typescript
Build-Depends-Indep: node-less
Standards-Version: 3.9.6
Homepage: http://grafana.org
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/grafana.git
Vcs-Git: https://anonscm.debian.org/collab-maint/grafana.git

Package: grafana
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, grafana-data (= ${source:Version})
        ,golang-go
        ,adduser
        ,libfontconfig
Built-Using: ${misc:Built-Using}
Description: feature rich metrics dashboard and graph editor
 Grafana is a feature rich metrics dashboard and graph editor for Graphite,
 InfluxDB & OpenTSDB.
 .
 This package provides Grafana daemon.

Package: grafana-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
    ,fonts-font-awesome
    ,libjs-angularjs
    ,libjs-jquery
##    ,libjs-jquery-flot
    ,libjs-twitter-bootstrap
#    ,phantomjs {removed from unstable}
Recommends: grafana
Built-Using: ${misc:Built-Using}
Description: feature rich metrics dashboard and graph editor - data files
 Grafana is a feature rich metrics dashboard and graph editor for Graphite,
 InfluxDB & OpenTSDB.
 .
 This package provide files for the web interface.

#Package: golang-github-grafana-grafana-dev
#Architecture: all
#Depends: ${misc:Depends}, ${shlibs:Depends}
#Built-Using: ${misc:Built-Using}
#Description: feature rich metrics dashboard and graph editor
# Grafana is a feature rich metrics dashboard and graph editor for Graphite,
# InfluxDB & OpenTSDB.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

export DH_GOPKG := github.com/grafana/grafana

TS=$(shell find public -type f -name '*.ts' -print)
JS=$(TS:ts=js)

%:
	dh $@ --buildsystem=golang --with=golang,systemd --builddirectory=_build --parallel

override_dh_clean:
	dh_clean $(JS)
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`

override_dh_auto_configure:
	dh_auto_configure
	##
	## symlink github.com/macaron-contrib (legacy, to remove after 2.7.0):
	#$(RM) -f _build/src/github.com/macaron-contrib
	mkdir -p _build/src/github.com/macaron-contrib
	-ln -sfvr _build/src/$(DH_GOPKG)/Godeps/_workspace/src/github.com/macaron-contrib/*  _build/src/github.com/macaron-contrib/
	##
	## symlink github.com/go-macaron/*:
	$(RM) -f _build/src/github.com/go-macaron
	mkdir -p _build/src/github.com/go-macaron
	-ln -sv  /usr/share/gocode/src/github.com/go-macaron/*  _build/src/github.com/go-macaron/
	-ln -sfvr _build/src/$(DH_GOPKG)/Godeps/_workspace/src/github.com/go-macaron/*  _build/src/github.com/go-macaron/
	##
	## symlink src/gopkg.in/*:
	$(RM) -f _build/src/gopkg.in
	mkdir -p _build/src/gopkg.in
	-ln -sv  /usr/share/gocode/src/gopkg.in/*  _build/src/gopkg.in/
	-ln -sfvr _build/src/$(DH_GOPKG)/Godeps/_workspace/src/gopkg.in/*  _build/src/gopkg.in/

build-indep:
	## Build CSS: http://lesscss.org/usage/index.html
	-mkdir -p public/css
	cd public/css \
        && lessc --include-path=../less --include-path=../vendor/bootstrap/less ../less/bootstrap.dark.less grafana.dark.min.css \
        && lessc --include-path=../less --include-path=../vendor/bootstrap/less ../less/bootstrap.light.less grafana.light.min.css
	tsc --module amd $(TS)
## Probably should be
##	tsc -p .
## but doesn't work due to
##   error TS6053: File 'public/app/features/dashboard/timepicker/timerange.ts' not found.

override_dh_install:
	dh_install -XLICENSE -Xlicense.json
	## rename config file:
	mv -v debian/grafana/etc/grafana/sample.ini  debian/grafana/etc/grafana/grafana.ini

override_dh_link:
	## link minified .CSS and .JS with to their uncompressed versions:
	find $(CURDIR)/debian/grafana-data/usr -type f -name "*[-.]min.css" -or -name "*[-.]min.js" | \
        while read MF; do \
            UF="$$(echo $${MF} | perl -pE 's{[\.-]min\.(js|css)}{.$$1};')" ;\
            if [ -f "$${UF}" ] || [ -n "$$(readlink \"$${UF}\")" ]; then \
                ln -svfr "$${UF}" "$${MF}" ;\
            fi ;\
        done
	dh_link

override_dh_fixperms:
	dh_fixperms
	## executable-not-elf-or-script:
	-chmod -R -c a-x+X \
            debian/grafana-data/usr/share/grafana/public

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

#override_dh_installinit:
#	dh_installinit --no-start

#override_dh_systemd_start:
#	dh_systemd_start --no-start

#override_dh_systemd_enable:
#	dh_systemd_enable --no-enable

override_dh_auto_test:
	#-dh_auto_test

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+)\Z}{.$1},\
 https://github.com/grafana/grafana/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

## grafana 11.5.2

=== Makefile ===
## This is a self-documented Makefile. For usage information, run `make help`:
##
## For more information, refer to https://suva.sh/posts/well-documented-makefiles/

WIRE_TAGS = "oss"

-include local/Makefile
include .bingo/Variables.mk

GO = go
GO_VERSION = 1.23.5
GO_LINT_FILES ?= $(shell ./scripts/go-workspace/golangci-lint-includes.sh)
GO_TEST_FILES ?= $(shell ./scripts/go-workspace/test-includes.sh)
SH_FILES ?= $(shell find ./scripts -name *.sh)
GO_RACE  := $(shell [ -n "$(GO_RACE)" -o -e ".go-race-enabled-locally" ] && echo 1 )
GO_RACE_FLAG := $(if $(GO_RACE),-race)
GO_BUILD_FLAGS += $(if $(GO_BUILD_DEV),-dev)
GO_BUILD_FLAGS += $(if $(GO_BUILD_TAGS),-build-tags=$(GO_BUILD_TAGS))
GO_BUILD_FLAGS += $(GO_RACE_FLAG)
GIT_BASE = remotes/origin/main

# GNU xargs has flag -r, and BSD xargs (e.g. MacOS) has that behaviour by default
XARGSR = $(shell xargs --version 2>&1 | grep -q GNU && echo xargs -r || echo xargs)

targets := $(shell echo '$(sources)' | tr "," " ")

GO_INTEGRATION_TESTS := $(shell find ./pkg -type f -name '*_test.go' -exec grep -l '^func TestIntegration' '{}' '+' | grep -o '\(.*\)/' | sort -u)

.PHONY: all
all: deps build

##@ Dependencies

.PHONY: deps-go
deps-go: ## Install backend dependencies.
	$(GO) run $(GO_RACE_FLAG) build.go setup

.PHONY: deps-js
deps-js: node_modules ## Install frontend dependencies.

.PHONY: deps
deps: deps-js ## Install all dependencies.

.PHONY: node_modules
node_modules: package.json yarn.lock ## Install node modules.
	@echo "install frontend dependencies"
	YARN_ENABLE_PROGRESS_BARS=false yarn install --immutable

##@ Swagger
SPEC_TARGET = public/api-spec.json
ENTERPRISE_SPEC_TARGET = public/api-enterprise-spec.json
MERGED_SPEC_TARGET = public/api-merged.json
NGALERT_SPEC_TARGET = pkg/services/ngalert/api/tooling/api.json

$(NGALERT_SPEC_TARGET):
	+$(MAKE) -C pkg/services/ngalert/api/tooling api.json

$(MERGED_SPEC_TARGET): swagger-oss-gen swagger-enterprise-gen $(NGALERT_SPEC_TARGET) $(SWAGGER) ## Merge generated and ngalert API specs
	# known conflicts DsPermissionType, AddApiKeyCommand, Json, Duration (identical models referenced by both specs)
	$(SWAGGER) mixin -q $(SPEC_TARGET) $(ENTERPRISE_SPEC_TARGET) $(NGALERT_SPEC_TARGET) --ignore-conflicts -o $(MERGED_SPEC_TARGET)

.PHONY: swagger-oss-gen
swagger-oss-gen: $(SWAGGER) ## Generate API Swagger specification
	@echo "re-generating swagger for OSS"
	rm -f $(SPEC_TARGET)
	SWAGGER_GENERATE_EXTENSION=false $(SWAGGER) generate spec -q -m -w pkg/server -o $(SPEC_TARGET) \
	-x "github.com/grafana/grafana/pkg/services/ngalert/api/tooling/definitions" \
	-x "github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-openapiv2/options" \
	-x "github.com/prometheus/alertmanager" \
	-i pkg/api/swagger_tags.json \
	--exclude-tag=alpha \
	--exclude-tag=enterprise

# this file only exists if enterprise is enabled
.PHONY: swagger-enterprise-gen
ENTERPRISE_EXT_FILE = pkg/extensions/ext.go
ifeq ("$(wildcard $(ENTERPRISE_EXT_FILE))","") ## if enterprise is not enabled
swagger-enterprise-gen:
	@echo "skipping re-generating swagger for enterprise: not enabled"
else
swagger-enterprise-gen: $(SWAGGER) ## Generate API Swagger specification
	@echo "re-generating swagger for enterprise"
	rm -f $(ENTERPRISE_SPEC_TARGET)
	SWAGGER_GENERATE_EXTENSION=false $(SWAGGER) generate spec -q -m -w pkg/server -o $(ENTERPRISE_SPEC_TARGET) \
	-x "github.com/grafana/grafana/pkg/services/ngalert/api/tooling/definitions" \
	-x "github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-openapiv2/options" \
	-x "github.com/prometheus/alertmanager" \
	-i pkg/api/swagger_tags.json \
	--exclude-tag=alpha \
	--include-tag=enterprise
endif

.PHONY: swagger-gen
swagger-gen: gen-go $(MERGED_SPEC_TARGET) swagger-validate

.PHONY: swagger-validate
swagger-validate: $(MERGED_SPEC_TARGET) $(SWAGGER) ## Validate API spec
	$(SWAGGER) validate --skip-warnings $(<)

.PHONY: swagger-clean
swagger-clean:
	rm -f $(SPEC_TARGET) $(MERGED_SPEC_TARGET) $(OAPI_SPEC_TARGET)

.PHONY: cleanup-old-git-hooks
cleanup-old-git-hooks:
	./scripts/cleanup-husky.sh

.PHONY: lefthook-install
lefthook-install: cleanup-old-git-hooks $(LEFTHOOK) # install lefthook for pre-commit hooks
	$(LEFTHOOK) install -f

.PHONY: lefthook-uninstall
lefthook-uninstall: $(LEFTHOOK)
	$(LEFTHOOK) uninstall

##@ OpenAPI 3
OAPI_SPEC_TARGET = public/openapi3.json

.PHONY: openapi3-gen
openapi3-gen: swagger-gen ## Generates OpenApi 3 specs from the Swagger 2 already generated
	$(GO) run $(GO_RACE_FLAG) scripts/openapi3/openapi3conv.go $(MERGED_SPEC_TARGET) $(OAPI_SPEC_TARGET)

##@ Internationalisation
.PHONY: i18n-extract-enterprise
ENTERPRISE_FE_EXT_FILE = public/app/extensions/index.ts
ifeq ("$(wildcard $(ENTERPRISE_FE_EXT_FILE))","") ## if enterprise is not enabled
i18n-extract-enterprise:
	@echo "Skipping i18n extract for Enterprise: not enabled"
else
i18n-extract-enterprise:
	@echo "Extracting i18n strings for Enterprise"
	yarn run i18next --config public/locales/i18next-parser-enterprise.config.cjs
	node ./public/locales/pseudo.mjs --mode enterprise
endif

.PHONY: i18n-extract
i18n-extract: i18n-extract-enterprise
	@echo "Extracting i18n strings for OSS"
	yarn run i18next --config public/locales/i18next-parser.config.cjs
	node ./public/locales/pseudo.mjs --mode oss

##@ Building
.PHONY: gen-cue
gen-cue: ## Do all CUE/Thema code generation
	@echo "generate code from .cue files"
	go generate ./kinds/gen.go
	go generate ./public/app/plugins/gen.go

.PHONY: gen-cuev2
gen-cuev2: ## Do all CUE code generation
	@echo "generate code from .cue files (v2)"
	go generate ./kindsv2/gen.go

.PHONY: gen-feature-toggles
gen-feature-toggles:
## First go test run fails because it will re-generate the feature toggles.
## Second go test run will compare the generated files and pass.
	@echo "generate feature toggles"
	go test -v ./pkg/services/featuremgmt/... > /dev/null 2>&1; \
	if [ $$? -eq 0 ]; then \
		echo "feature toggles already up-to-date"; \
	else \
		go test -v ./pkg/services/featuremgmt/...; \
	fi

.PHONY: gen-go
gen-go:
	@echo "generate go files"
	$(GO) run $(GO_RACE_FLAG) ./pkg/build/wire/cmd/wire/main.go gen -tags $(WIRE_TAGS) ./pkg/server

.PHONY: fix-cue
fix-cue: $(CUE)
	@echo "formatting cue files"
	$(CUE) fix kinds/**/*.cue
	$(CUE) fix public/app/plugins/**/**/*.cue

.PHONY: gen-jsonnet
gen-jsonnet:
	go generate ./devenv/jsonnet

.PHONY: update-workspace
update-workspace: gen-go
	@echo "updating workspace"
	bash scripts/go-workspace/update-workspace.sh

.PHONY: build-go
build-go: gen-go update-workspace ## Build all Go binaries.
	@echo "build go files with updated workspace"
	$(GO) run build.go $(GO_BUILD_FLAGS) build

build-go-fast: gen-go ## Build all Go binaries.
	@echo "build go files"
	$(GO) run build.go $(GO_BUILD_FLAGS) build

.PHONY: build-backend
build-backend: ## Build Grafana backend.
	@echo "build backend"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-backend

.PHONY: build-server
build-server: ## Build Grafana server.
	@echo "build server"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-server

.PHONY: build-cli
build-cli: ## Build Grafana CLI application.
	@echo "build grafana-cli"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-cli

.PHONY: build-js
build-js: ## Build frontend assets.
	@echo "build frontend"
	yarn run build
	yarn run plugins:build-bundled

PLUGIN_ID ?=

.PHONY: build-plugin-go
build-plugin-go: ## Build decoupled plugins
	@echo "build plugin $(PLUGIN_ID)"
	@cd pkg/tsdb; \
	if [ -z "$(PLUGIN_ID)" ]; then \
		echo "PLUGIN_ID is not set"; \
		exit 1; \
	fi; \
	mage -v buildplugin $(PLUGIN_ID)

.PHONY: build
build: build-go build-js ## Build backend and frontend.

.PHONY: run
run: $(BRA) ## Build and run web server on filesystem changes. See /.bra.toml for configuration.
	$(BRA) run

.PHONY: run-go
run-go: ## Build and run web server immediately.
	$(GO) run -race $(if $(GO_BUILD_TAGS),-build-tags=$(GO_BUILD_TAGS)) \
		./pkg/cmd/grafana -- server -profile -profile-addr=127.0.0.1 -profile-port=6000 -packaging=dev cfg:app_mode=development

.PHONY: run-frontend
run-frontend: deps-js ## Fetch js dependencies and watch frontend for rebuild
	yarn start

##@ Testing

.PHONY: test-go
test-go: test-go-unit test-go-integration

.PHONY: test-go-unit
test-go-unit: ## Run unit tests for backend with flags.
	@echo "test backend unit tests"
	printf '$(GO_TEST_FILES)' | xargs \
	$(GO) test $(GO_RACE_FLAG) -short -covermode=atomic -timeout=30m

.PHONY: test-go-unit-pretty
test-go-unit-pretty: check-tparse
	@if [ -z "$(FILES)" ]; then \
		echo "Notice: FILES variable is not set. Try \"make test-go-unit-pretty FILES=./pkg/services/mysvc\""; \
		exit 1; \
	fi
	$(GO) test $(GO_RACE_FLAG) -timeout=10s $(FILES) -json | tparse -all

.PHONY: test-go-integration
test-go-integration: ## Run integration tests for backend with flags.
	@echo "test backend integration tests"
	$(GO) test $(GO_RACE_FLAG) -count=1 -run "^TestIntegration" -covermode=atomic -timeout=5m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-alertmanager
test-go-integration-alertmanager: ## Run integration tests for the remote alertmanager (config taken from the mimir_backend block).
	@echo "test remote alertmanager integration tests"
	$(GO) clean -testcache
	AM_URL=http://localhost:8080 AM_TENANT_ID=test \
	$(GO) test $(GO_RACE_FLAG) -count=1 -run "^TestIntegrationRemoteAlertmanager" -covermode=atomic -timeout=5m ./pkg/services/ngalert/...

.PHONY: test-go-integration-postgres
test-go-integration-postgres: devenv-postgres ## Run integration tests for postgres backend with flags.
	@echo "test backend integration postgres tests"
	$(GO) clean -testcache
	GRAFANA_TEST_DB=postgres \
	$(GO) test $(GO_RACE_FLAG) -p=1 -count=1 -run "^TestIntegration" -covermode=atomic -timeout=10m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-mysql
test-go-integration-mysql: devenv-mysql ## Run integration tests for mysql backend with flags.
	@echo "test backend integration mysql tests"
	GRAFANA_TEST_DB=mysql \
	$(GO) test $(GO_RACE_FLAG) -p=1 -count=1 -run "^TestIntegration" -covermode=atomic -timeout=10m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-redis
test-go-integration-redis: ## Run integration tests for redis cache.
	@echo "test backend integration redis tests"
	$(GO) clean -testcache
	REDIS_URL=localhost:6379 $(GO) test $(GO_RACE_FLAG) -run IntegrationRedis -covermode=atomic -timeout=2m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-memcached
test-go-integration-memcached: ## Run integration tests for memcached cache.
	@echo "test backend integration memcached tests"
	$(GO) clean -testcache
	MEMCACHED_HOSTS=localhost:11211 $(GO) test $(GO_RACE_FLAG) -run IntegrationMemcached -covermode=atomic -timeout=2m $(GO_INTEGRATION_TESTS)

.PHONY: test-js
test-js: ## Run tests for frontend.
	@echo "test frontend"
	yarn test

.PHONY: test
test: test-go test-js ## Run all tests.

##@ Linting
.PHONY: golangci-lint
golangci-lint: $(GOLANGCI_LINT)
	@echo "lint via golangci-lint"
	$(GOLANGCI_LINT) run \
		--config .golangci.yml \
		$(GO_LINT_FILES)

.PHONY: lint-go
lint-go: golangci-lint ## Run all code checks for backend. You can use GO_LINT_FILES to specify exact files to check

.PHONY: lint-go-diff
lint-go-diff: $(GOLANGCI_LINT)
	git diff --name-only $(GIT_BASE) | \
		grep '\.go$$' | \
		$(XARGSR) dirname | \
		sort -u | \
		sed 's,^,./,' | \
		$(XARGSR) $(GOLANGCI_LINT) run --config .golangci.toml

# with disabled SC1071 we are ignored some TCL,Expect `/usr/bin/env expect` scripts
.PHONY: shellcheck
shellcheck: $(SH_FILES) ## Run checks for shell scripts.
	@docker run --rm -v "$$PWD:/mnt" koalaman/shellcheck:stable \
	$(SH_FILES) -e SC1071 -e SC2162

##@ Docker

TAG_SUFFIX=$(if $(WIRE_TAGS)!=oss,-$(WIRE_TAGS))
PLATFORM=linux/amd64

.PHONY: build-docker-full
build-docker-full: ## Build Docker image for development.
	@echo "build docker container"
	tar -ch . | \
	docker buildx build - \
	--platform $(PLATFORM) \
	--build-arg BINGO=false \
	--build-arg GO_BUILD_TAGS=$(GO_BUILD_TAGS) \
	--build-arg WIRE_TAGS=$(WIRE_TAGS) \

## grafana fastmcp-1.2.2

=== requirements.txt ===
httpx>=0.27
mcp>=0.1.0; python_version >= "3.10"
starlette>=0.31
python-dotenv>=1.0

## grafana fastmcp-1.2.3

=== Makefile ===
.DEFAULT_GOAL := help

PYTHON ?= python3
VENV ?= .venv
VENV_BIN := $(VENV)/bin
VENV_PYTHON := $(VENV_BIN)/python
VENV_PIP := $(VENV_BIN)/pip
REQUIREMENTS ?= requirements.txt
PACKAGE_NAME ?= grafana-mcp

# uv / uvx tooling
UV ?= uv
UVX ?= uvx
UV_GROUPS ?= --all-groups
UV_RUN ?= $(UV) run

IMAGE_NAME ?= grafana-ai-data-driven
CONTAINER_NAME ?= grafana-ai-data-driven
APP_PORT ?= 8000
APP_ADDRESS ?= 0.0.0.0:8000
BASE_PATH ?= /
LOG_LEVEL ?= INFO
TRANSPORT ?= stdio
ENV_FILE ?= .env

.PHONY: uv-bootstrap
uv-bootstrap:
	@if ! command -v $(UV) >/dev/null 2>&1; then \
		curl -Ls https://astral.sh/uv/install.sh | sh; \
		. $$HOME/.cargo/env >/dev/null 2>&1 || true; \
	fi
	@$(UV) --version

.PHONY: uv-sync
uv-sync: uv-bootstrap
	@$(UV) sync $(UV_GROUPS)

.PHONY: uv-local
uv-local: uv-sync
	@set -a; \
		if [ -f "$(ENV_FILE)" ]; then . "$(ENV_FILE)"; fi; \
		set +a; \
		$(UV_RUN) -m app --address $(APP_ADDRESS) --base-path $(BASE_PATH) --log-level $(LOG_LEVEL) --transport $(TRANSPORT)

.PHONY: uv-test
uv-test: uv-sync
	@$(UV_RUN) pytest -q

.PHONY: uv-cov
uv-cov: uv-sync
	@$(UV_RUN) pytest --cov=. --cov-report term-missing

.PHONY: uv-lint
uv-lint: uv-sync
	@$(UV_RUN) ruff check .

.PHONY: uv-fmt
uv-fmt: uv-sync
	@$(UV_RUN) ruff format .

.PHONY: uv-typecheck
uv-typecheck: uv-sync
	@$(UV_RUN) mypy app tests

.PHONY: uv-package
uv-package: uv-sync
	@$(UVX) pyinstaller --clean --onefile --name $(PACKAGE_NAME) run_app.py

.PHONY: uv-lock
uv-lock:
	@$(UV) lock

.PHONY: venv
venv:
	@if [ ! -x "$(VENV_PYTHON)" ]; then \
		$(PYTHON) -m venv $(VENV) && \
		$(VENV_PIP) install --upgrade pip; \
	fi
	@if [ -f "$(REQUIREMENTS)" ]; then \
		$(VENV_PIP) install -r $(REQUIREMENTS); \
	fi

.PHONY: local

local: venv
	@set -a; \
		if [ -f "$(ENV_FILE)" ]; then . "$(ENV_FILE)"; fi; \
		set +a; \
                $(VENV_PYTHON) -m app --address $(APP_ADDRESS) --base-path $(BASE_PATH) --log-level $(LOG_LEVEL) --transport $(TRANSPORT)

.PHONY: package
package: venv
	@$(VENV_PIP) install --upgrade pyinstaller >/dev/null
	@$(VENV_BIN)/pyinstaller --clean --onefile --name $(PACKAGE_NAME) run_app.py

.PHONY: docker
docker:
	@docker build -t $(IMAGE_NAME) -f Dockerfile .
	@ENV_FILE_OPT=""; \
		if [ -f "$(ENV_FILE)" ]; then ENV_FILE_OPT="--env-file $(ENV_FILE)"; fi; \
                docker run --rm -it --name $(CONTAINER_NAME) $$ENV_FILE_OPT -e LOG_LEVEL=$(LOG_LEVEL) -e APP_ADDRESS=$(APP_ADDRESS) -e BASE_PATH=$(BASE_PATH) -e TRANSPORT=$(TRANSPORT) -p $(APP_PORT):$(APP_PORT) $(IMAGE_NAME)

.PHONY: podman
podman:
	@podman build -t $(IMAGE_NAME) -f Dockerfile .
	@ENV_FILE_OPT=""; \
		if [ -f "$(ENV_FILE)" ]; then ENV_FILE_OPT="--env-file $(ENV_FILE)"; fi; \
                podman run --rm -it --name $(CONTAINER_NAME) $$ENV_FILE_OPT -e LOG_LEVEL=$(LOG_LEVEL) -e APP_ADDRESS=$(APP_ADDRESS) -e BASE_PATH=$(BASE_PATH) -e TRANSPORT=$(TRANSPORT) -p $(APP_PORT):$(APP_PORT) $(IMAGE_NAME)

.PHONY: clean
clean:
	@rm -rf $(VENV)
	@find . -type d -name '__pycache__' -prune -exec rm -rf {} +

.PHONY: clean-docker
clean-docker:
	@docker rm -f $(CONTAINER_NAME) 2>/dev/null || true
	@docker rmi -f $(IMAGE_NAME) 2>/dev/null || true

.PHONY: clean-podman
clean-podman:
	@podman rm -f $(CONTAINER_NAME) 2>/dev/null || true
	@podman rmi -f $(IMAGE_NAME) 2>/dev/null || true

.PHONY: help
help:
	@echo "Comandos disponíveis:"
	@echo "  make venv          - Cria/atualiza o ambiente virtual local"
	@echo "  make local         - Cria (se necessário) o venv e executa a aplicação localmente"
	@echo "  make package       - Gera um executável único via PyInstaller em dist/"
	@echo "  make docker        - Faz build e executa a imagem no Docker"
	@echo "  make podman        - Faz build e executa a imagem no Podman"
	@echo "  make clean         - Remove o ambiente virtual e caches Python"
	@echo "  make clean-docker  - Remove container/imagem do Docker"
	@echo "  make clean-podman  - Remove container/imagem do Podman"
	@echo "  make help          - Mostra este help"
	@echo ""
	@echo "Atalhos com uv/uvx (recomendado):"
	@echo "  make uv-sync       - Sincroniza dependências a partir de pyproject.toml/uv.lock"
	@echo "  make uv-local      - Executa o servidor usando uv run (carrega .env automaticamente)"
	@echo "  make uv-test       - Roda testes com pytest"
	@echo "  make uv-cov        - Roda testes com cobertura"
	@echo "  make uv-lint       - Roda ruff check"
	@echo "  make uv-fmt        - Roda ruff format"
	@echo "  make uv-typecheck  - Roda mypy"
	@echo "  make uv-package    - Gera executável via uvx pyinstaller"
	@echo "  make uv-lock       - Atualiza/regenera o lockfile (uv.lock)"

=== requirements.txt ===
httpx>=0.27
mcp>=0.1.0; python_version >= "3.10"
starlette>=0.31
python-dotenv>=1.0
pytest-asyncio>=0.20
